; CMATH17.ASM
;
; This file defines all of the variables used by the various math routines.  It
; was developed from the original CMATH17.INC from Frank Testa.  The INC file now
; contains the generic equates and EXTERN definitions needed for the various
; routines.

;   RCS Header $Id: CMATH17.ASM,v 1.2 2000/02/22 22:15:27 krt Exp $

;   $Revision: 1.2 $

;       CMATH17 DATA DEFINITION FILE

MATH_DATA      UDATA

;*******************************************************************************
;   VARIABLE ALLOCATION - Generic
;*******************************************************************************

ACCB7           RES 1
ACCB6           RES 1
ACCB5           RES 1
ACCB4           RES 1
ACCB3           RES 1
ACCB2           RES 1
ACCB1           RES 1
ACCB0
ACC             RES 1       ; most significant byte of contiguous 8 byte accumulator

EXP                         ; 8 bit biased exponent
SIGN            RES 1       ; save location for sign in MSB
FPFLAGS         RES     1       ; floating point library exception flags


        GLOBAL  ACCB7, ACCB6, ACCB5, ACCB4  
        GLOBAL  ACCB3, ACCB2, ACCB1, ACCB0  
        GLOBAL  ACC    
        GLOBAL  EXP, AEXP, SIGN, FPFLAGS

;*******************************************************************************
;   VARIABLE ALLOCATION - Binary Operations
;*******************************************************************************

AARGB7          RES 1
AARGB6          RES 1
AARGB5          RES 1
AARGB4          RES 1
AARGB3          RES 1
AARGB2          RES 1
AARGB1          RES 1
AARGB0          
AARG            RES 1       ; most significant byte of argument A
AEXP            RES 1       ; 8 bit biased exponent for argument A
                RES 3   ; place holder for exponent, sign, and exceptions
BARGB3          RES 1
BARGB2          RES 1
BARGB1          RES 1
BARGB0          
BARG            RES 1       ; most significant byte of argument B

BEXP            RES 1       ; 8 bit biased exponent for argument B

TEMPB3          RES 1
TEMPB2          RES 1
TEMPB1          RES 1
TEMPB0          
TEMP            RES 1       ; temporary storage


        GLOBAL  AARGB7, AARGB6, AARGB5, AARGB4
        GLOBAL  AARGB3, AARGB2, AARGB1, AARGB0
        GLOBAL  AARG
        GLOBAL  BARGB3, BARGB2, BARGB1, BARGB0
        GLOBAL  BARG
        GLOBAL  BEXP
        GLOBAL  TEMPB3, TEMPB2, TEMPB1, TEMPB0
        GLOBAL  TEMP

;*******************************************************************************
;   VARIABLE ALLOCATION - Remainder Storage
;*******************************************************************************

REMB3           RES     1
REMB2           RES     1
REMB1           RES     1
REMB0           RES     1       ; most significant byte of remainder


        GLOBAL  REMB3, REMB2, REMB1, REMB0

;*******************************************************************************
;   VARIABLE ALLOCATION - Additional Routines
;*******************************************************************************

COUNTER     RES 1

CEXP        RES 1
CARGB0      RES 1
CARGB1      RES 1
CARGB2      RES 1
CARGB3      RES 1

DEXP        RES 1
DARGB0      RES 1
DARGB1      RES 1
DARGB2      RES 1
DARGB3      RES 1

EEXP        RES 1
EARGB0      RES 1
EARGB1      RES 1
EARGB2      RES 1
EARGB3      RES 1

FEXP        RES 1
FARGB0      RES 1
FARGB1      RES 1
FARGB2      RES 1
FARGB3      RES 1

GEXP        RES 1
GARGB0      RES 1
GARGB1      RES 1
GARGB2      RES 1
GARGB3      RES 1

ZARGB0      RES 1
ZARGB1      RES 1
ZARGB2      RES 1
ZARGB3      RES 1

RANDB0      RES 1
RANDB1      RES 1
RANDB2      RES 1
RANDB3      RES 1


        GLOBAL  CEXP, CARGB0, CARGB1, CARGB2, CARGB3
        GLOBAL  DEXP, DARGB0, DARGB1, DARGB2, DARGB3
        GLOBAL  EEXP, EARGB0, EARGB1, EARGB2, EARGB3
        GLOBAL  FEXP, FARGB0, FARGB1, FARGB2, FARGB3
        GLOBAL  GEXP, GARGB0, GARGB1, GARGB2, GARGB3
        GLOBAL  ZARGB0, ZARGB1, ZARGB2, ZARGB3
        GLOBAL  RANDB0, RANDB1, RANDB2, RANDB3
        GLOBAL  COUNTER

        END
