;	RCS Header $Id: FXD0808S.ASM,v 1.2 2000/02/22 22:15:27 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       8/8 Bit Signed Fixed Point Divide 08/08 -> 08.08

;       Input:  8 bit fixed point dividend in AARGB0
;               8 bit fixed point divisor in BARGB0

;       Use:    CALL    FXD0808S

;       Output: 8 bit fixed point quotient in AARGB0
;               8 bit fixed point remainder in REMB0

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	21	52	38.90	clks

;       PM: 25        DM: 5

;----------------------------------------------------------------------------------------------

PROG		CODE

FXD0808S
			GLOBAL	FXD0808S
			EXTERN	FXD0808U

			CLRF	SIGN,F		; clear sign

            BTFSS	BARGB0,MSB
            GOTO 	DA0808S

            COMF 	BARGB0, F	; if BARG<0, negate and toggle sign
            INCF 	BARGB0, F
			COMF	SIGN,F

DA0808S 	BTFSS	AARGB0,MSB
            GOTO 	D0808S

            COMF 	AARGB0, F	; if AARG<0, negate and toggle sign
            INCF 	AARGB0, F
			COMF	SIGN,F

D0808S      CALL	FXD0808U

			BTFSC	AARGB0,MSB	; test for exception
			GOTO	D0808SX

D0808SOK
	        BTFSS   SIGN,MSB
            RETLW   0x00
D0808SNEG
            COMF	AARGB0,F	; negate if result negative
            INCF	AARGB0,F

            COMF	REMB0,F
            INCF	REMB0,F

            RETLW   0x00

D0808SX
			BTFSC	SIGN,MSB
			GOTO	D0808SNEG
			BSF		FPFLAGS,NAN	; NAN exception if AARG=0x80
			RETLW	0xFF		; with positive sign

			END

