;	RCS Header $Id: FXD1608S.ASM,v 1.2 2000/02/22 22:15:27 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       16/8 Bit Signed Fixed Point Divide 16/08 -> 16.08

;       Input:  16 bit fixed point dividend in AARGB0, AARGB1
;               8 bit fixed point divisor in BARGB0

;       Use:    CALL    FXD1608S

;       Output: 16 bit fixed point quotient in AARGB0, AARGB1
;               8 bit fixed point remainder in REMB0

;       Result: AARG, REM  <--  AARG / BARG


;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	21	80	69.94	clks

;       PM: 29             DM: 6

;----------------------------------------------------------------------------------------------

PROG		CODE

			EXTERN		FXD1608U

FXD1608S
			GLOBAL		FXD1608S

			CLRF		SIGN,F		; clear sign

            BTFSS       BARGB0,MSB
            GOTO        DA1608S

            COMF        BARGB0,F	; if BARG<0, negate and toggle sign
            INCF        BARGB0,F
			COMF		SIGN,F

DA1608S     BTFSS       AARGB0,MSB
            GOTO        C1608S

            COMF        AARGB1,F	; if AARG<0, negate and toggle sign
            COMF        AARGB0,F
            INFSNZ		AARGB1,F
            INCF		AARGB0,F
			COMF		SIGN,F

C1608S      CALL		FXD1608U

			BTFSC		AARGB0,MSB	; test for exception
			GOTO		D1608SX

D1608SOK
			BTFSS       SIGN,MSB 
            RETLW       0x00

D1608SNEG
            COMF        AARGB1,F	; negate if result negative
            COMF        AARGB0,F
            INFSNZ		AARGB1,F
            INCF		AARGB0,F

            COMF        REMB0,F
            INCF        REMB0,F

            RETLW       0x00

D1608SX
			BTFSC		SIGN,MSB
			GOTO		D1608SNEG
			BSF			FPFLAGS,NAN	; NAN exception if AARG=0x8000
			RETLW		0xFF		; with positive sign

			END