;	RCS Header $Id: FXD1608U.ASM,v 1.2 2000/02/22 22:15:27 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       16/8 Bit Unsigned Fixed Point Divide 16/08 -> 16.08

;       Input:  16 bit unsigned fixed point dividend in AARGB0, AARGB1
;                8 bit unsigned fixed point divisor in BARGB0

;       Use:    CALL    FXD1608U

;       Output: 16 bit unsigned fixed point quotient in AARGB0, AARGB1
;               8 bit unsigned fixed point remainder in REMB0

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	7	55	50.46	clks

;       PM: 55               DM: 7

;----------------------------------------------------------------------------------------------

PROG	CODE

		EXTERN		DREMZERO8
		EXTERN		IBXTBL256


FXD1608U
		GLOBAL		FXD1608U

		MOVLW		0x01
		CPFSGT		BARGB0
		GOTO		DREMZERO8

FXD1608U1
		GLOBAL		FXD1608U1

		MOVFP		BARGB0,WREG	; access reciprocal table
		ADDLW		LOW (IBXTBL256)
		MOVWF		TBLPTRL
		MOVLW		HIGH (IBXTBL256)
		CLRF		TBLPTRH,F
		ADDWFC		TBLPTRH,F
		TABLRD		0,1,WREG
FXD1608U2
		GLOBAL		FXD1608U2

		MOVFP		AARGB0,WREG
		MOVWF		REMB1
		MOVFP		AARGB1,WREG
		MOVWF		REMB0

		TLRD		1,WREG		; estimate quotient
		MULWF		REMB1
		MOVPF		PRODH,AARGB0
		MOVPF		PRODL,AARGB1

		TLRD		0,WREG
		MULWF		REMB0
		MOVPF		PRODH,AARGB2

		MULWF		REMB1
		MOVPF		PRODL,WREG
		ADDWF		AARGB2,F
		MOVPF		PRODH,WREG
		ADDWFC		AARGB1,F
		CLRF		WREG,F
		ADDWFC		AARGB0,F

		TLRD		1,WREG
		MULWF		REMB0
		MOVPF		PRODL,WREG
		ADDWF		AARGB2,F
		MOVPF		PRODH,WREG
		ADDWFC		AARGB1,F
		CLRF		WREG,F
		ADDWFC		AARGB0,F
		
		MOVFP		BARGB0,WREG
		MULWF		AARGB1
		MOVPF		PRODL,AARGB3
		MOVPF		PRODH,AARGB2
		MULWF		AARGB0
		MOVFP		PRODL,WREG
		ADDWF		AARGB2,F

		MOVFP		AARGB3,WREG		; estimate remainder
		SUBWF		REMB0,F
		MOVFP		AARGB2,WREG
		SUBWFB		REMB1,F

		BTFSS		REMB1,MSB		; test remainder
        RETLW		0x00

		DECF		AARGB1,F
		CLRF		WREG,F
		SUBWFB		AARGB0,F

		MOVFP		BARGB0,WREG
		ADDWF		REMB0,F

        RETLW		0x00

		END
