;	RCS Header $Id: FXD1616S.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       16/16 Bit Signed Fixed Point Divide 16/16 -> 16.16

;       Input:  16 bit fixed point dividend in AARGB0, AARGB1
;               16 bit fixed point divisor in BARGB0, BARGB1

;       Use:    CALL    FXD1616S

;       Output: 16 bit fixed point quotient in AARGB0, AARGB1
;               16 bit fixed point remainder in REMB0, REMB1

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	28	149	87.00	clks

;       PM: 33            DM: 8

;----------------------------------------------------------------------------------------------

PROG		CODE

			EXTERN		FXD1616U

FXD1616S
			GLOBAL		FXD1616S

			CLRF		SIGN,F		; clear sign

            BTFSS       BARGB0,MSB
            GOTO        DA1616S

            COMF        BARGB1,F	; if BARG<0, negate and toggle sign
            COMF        BARGB0,F
            INFSNZ		BARGB1,F
            INCF		BARGB0,F
			COMF		SIGN,F

DA1616S
	        BTFSS       AARGB0,MSB
            GOTO        D1616S

            COMF        AARGB1,F	; if AARG<0, negate and toggle sign
            COMF        AARGB0,F
            INFSNZ		AARGB1,F
            INCF		AARGB0,F
			COMF		SIGN,F

D1616S
			CALL		FXD1616U

			BTFSC		AARGB0,MSB	; test for exception
			GOTO		D1616SX

D1616SOK
			BTFSS       SIGN,MSB
			RETLW       0x00
D1616SNEG
            COMF        AARGB1,F	; negate if result negative
            COMF        AARGB0,F
            INFSNZ		AARGB1,F
            INCF	  	AARGB0,F

            COMF        REMB1,F
            COMF        REMB0,F
            INFSNZ		REMB1,F
            INCF	  	REMB0,F

            RETLW       0x00

D1616SX
			BTFSC		SIGN,MSB
			GOTO		D1616SNEG
			BSF			FPFLAGS,NAN	; NAN exception if AARG=0x8000
			RETLW		0xFF		; with positive sign

			END