;	RCS Header $Id: FXD1616U.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       16/16 Bit Unsigned Fixed Point Divide 16/16 -> 16.16

;       Input:  16 bit unsigned fixed point dividend in AARGB0, AARGB1
;               16 bit unsigned fixed point divisor in BARGB0, BARGB1

;       Use:    CALL    FXD1616U

;       Output: 16 bit unsigned fixed point quotient in AARGB0, AARGB1
;               16 bit unsigned fixed point remainder in REMB0, REMB1

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	14	122	61.77	clks

;       PM: 75               DM: 11

;----------------------------------------------------------------------------------------------

PROG	CODE

		EXTERN		FXD1608U
		EXTERN		D1616QZERO
		EXTERN		IBXTBL256
		EXTERN		FXD1608U1

FXD1616U
		GLOBAL		FXD1616U

		TSTFSZ		BARGB0
		GOTO		D1616B0GT0
		MOVFP		BARGB1,WREG
		MOVWF		BARGB0
		CALL		FXD1608U
		MOVFP		REMB0,WREG
		MOVWF		REMB1
		CLRF		REMB0,F
		RETLW		0x00

D1616B0GT0
		MOVFP		BARGB0,WREG
		SUBWF		AARGB0,W
		BTFSS		_C
		GOTO		D1616QZERO
		BTFSS		_Z
		GOTO		D1616AGEB

		MOVFP		BARGB1,WREG
		SUBWF		AARGB1,W
		BTFSS		_C
		GOTO		D1616QZERO

D1616AGEB
		MOVFP		AARGB0,WREG
		MOVWF		TEMPB0
		MOVFP		AARGB1,WREG
		MOVWF		TEMPB1

		MOVFP		AARGB1,WREG
		MOVWF		BEXP
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1
		CLRF		AARGB0,F

		MOVFP		BARGB0,WREG
		MOVWF		BARGB2
		MOVFP		BARGB1,WREG
		MOVWF		BARGB3

		BTFSC		BARGB0,MSB
		GOTO		D1616UNRMOK

		MOVFP		BARGB0,WREG	; access reciprocal table
;		ADDLW		LOW (IBXTBL256) + 1
		ADDLW		LOW (IBXTBL256 + 1)
		MOVWF		TBLPTRL
		MOVLW		HIGH (IBXTBL256)
		CLRF		TBLPTRH,F
		ADDWFC		TBLPTRH,F
		TABLRD		0,1,WREG

		TLRD		1,WREG		; normalize
		MULWF		BARGB3
		MOVPF		PRODL,BARGB1
		MOVPF		PRODH,BARGB0
		MULWF		BARGB2
		MOVFP		PRODL,WREG
		ADDWF		BARGB0,F

		TLRD		1,WREG
		MULWF		TEMPB1
		MOVPF		PRODL,BEXP
		MOVPF		PRODH,AARGB1
		MULWF		TEMPB0
		MOVPF		PRODL,WREG
		ADDWF		AARGB1,F
		CLRF		AARGB0,F
		MOVPF		PRODH,WREG
		ADDWFC		AARGB0,F

D1616UNRMOK
		CALL		FXD1608U1	; estimate quotient digit

		MOVFP		AARGB1,WREG
		MULWF		BARGB1

		MOVFP		PRODL,WREG
		SUBWF		BEXP,W
		MOVFP		PRODH,WREG
		SUBWFB		REMB0,W

		BTFSS		_C		; test
		DECF		AARGB1,F

D1616UQOK
		MOVFP		AARGB1,WREG	; calculate remainder
		MULWF		BARGB3
		MOVFP		PRODL,WREG
		SUBWF		TEMPB1,F
		MOVFP		PRODH,WREG
		SUBWFB		TEMPB0,F

		MOVFP		AARGB1,WREG
		MULWF		BARGB2
		MOVFP		PRODL,WREG
		SUBWF		TEMPB0,F

;	This test does not appear to be necessary in the 16 bit case, but
;	is included here in the event that a case appears after testing.

;		BTFSS		TEMPB0,MSB	; test
;		GOTO		D1616QOK
;		DECF		AARGB1,F

;		MOVFP		BARGB3,WREG
;		ADDWF		TEMPB1,F
;		MOVFP		BARGB2,WREG
;		ADDWFC		TEMPB0,F

D1616QOK
		MOVFP		TEMPB0,WREG
		MOVWF		REMB0
		MOVFP		TEMPB1,WREG
		MOVWF		REMB1

		RETLW           0x00

		END