;	RCS Header $Id: FXD3216U.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       32/16 Bit Unsigned Fixed Point Divide 32/16 -> 32.16

;       Input:  32 bit unsigned fixed point dividend in AARGB0, AARGB1, AARGB2
;               16 bit unsigned fixed point divisor in BARGB0, BARGB1

;       Use:    CALL    FXD3216U

;       Output: 32 bit unsigned fixed point quotient in AARGB0, AARGB1, AARGB2
;               16 bit unsigned fixed point remainder in REMB0, REMB1

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	48	391	323.28	clks

;       PM: 148               DM: 18

;----------------------------------------------------------------------------------------------

PROG	CODE

		EXTERN		FXD3208U
		EXTERN		FXD2416U
		EXTERN		DGETNRMD
		EXTERN		IBXTBL256
		EXTERN		FXD1608U2

FXD3216U
		GLOBAL		FXD3216U

		CLRF		REMB0,F
		CLRF		REMB1,F
		CLRF		WREG,F
		TSTFSZ		BARGB0
		GOTO		D3216BGT1
		MOVFP		BARGB1,WREG
		MOVWF		BARGB0
		CALL		FXD3208U
		MOVFP		REMB0,WREG
		MOVWF		REMB1
		CLRF		REMB0,F
		RETLW		0x00

D3216BGT1
		CPFSEQ		AARGB0
		GOTO		D3216AGTB
		MOVFP		AARGB1,WREG
		MOVWF		AARGB0
		MOVFP		AARGB2,WREG
		MOVWF		AARGB1
		MOVFP		AARGB3,WREG
		MOVWF		AARGB2
		CALL		FXD2416U
		
		MOVFP		AARGB2,WREG
		MOVWF		AARGB3
		MOVFP		AARGB1,WREG
		MOVWF		AARGB2
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1
		CLRF		AARGB0,F
		RETLW		0x00
D3216AGTB
		MOVFP		AARGB3,WREG
		MOVWF		BEXP
		MOVFP		AARGB2,WREG
		MOVWF		AARGB3
		MOVFP		AARGB1,WREG
		MOVWF		AARGB2
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1
		CLRF		AARGB0,F

		MOVFP		AARGB0,WREG
		MOVWF		TEMPB0
		MOVFP		AARGB1,WREG
		MOVWF		TEMPB1
		MOVFP		AARGB2,WREG
		MOVWF		TEMPB2
		MOVFP		AARGB3,WREG
		MOVWF		TEMPB3

		MOVLW		0x03		; set loop count
		MOVWF		AEXP

		MOVLW		0x01
		MOVWF		ZARGB0

		BTFSC		BARGB0,MSB
		GOTO		D3216UNRMOK

		CALL		DGETNRMD	; get normalization factor
		MOVWF		ZARGB0

		MULWF		BARGB1
		MOVFP		BARGB0,WREG
		MOVPF		PRODL,BARGB1
		MOVPF		PRODH,BARGB0
		MULWF		ZARGB0
		MOVFP		PRODL,WREG
		ADDWF		BARGB0,F

		MOVFP		ZARGB0,WREG
		MULWF		AARGB3
		MOVPF		PRODL,TEMPB3
		MOVPF		PRODH,TEMPB2
		MULWF		AARGB1
		MOVPF		PRODL,TEMPB1
		MOVPF		PRODH,TEMPB0
		MULWF		AARGB2
		MOVPF		PRODL,WREG
		ADDWF		TEMPB2,F
		MOVPF		PRODH,WREG
		ADDWF		TEMPB1,F
		MOVFP		ZARGB0,WREG
		MULWF		BEXP
		MOVPF		PRODL,BEXP
		MOVFP		PRODH,WREG
		ADDWF		TEMPB3,F

D3216UNRMOK
		MOVFP		BARGB0,WREG	; access reciprocal table
		ADDLW		LOW (IBXTBL256)
		MOVWF		TBLPTRL
		MOVLW		HIGH (IBXTBL256)
		CLRF		TBLPTRH,F
		ADDWFC		TBLPTRH,F
		TABLRD		0,1,WREG

D3216ULOOP
		MOVFP		TEMPB0,WREG
		MOVWF		AARGB0
		MOVFP		TEMPB1,WREG
		MOVWF		AARGB1

		CALL		FXD1608U2	; estimate quotient digit

		BTFSS		AARGB0,LSB
		GOTO		D3216UQTEST

		SETF		AARGB1,F
		MOVFP		TEMPB1,WREG
		MOVWF		REMB0
		MOVFP		BARGB0,WREG
		ADDWF		REMB0,F

		BTFSC		_C		; test
		GOTO		D3216UQOK

D3216UQTEST
		MOVFP		AARGB1,WREG
		MULWF		BARGB1

		MOVFP		PRODL,WREG
		SUBWF		TEMPB2,W
		MOVFP		PRODH,WREG
		SUBWFB		REMB0,W

		BTFSC		_C		; test
		GOTO		D3216UQOK

		DECF		AARGB1,F

		MOVFP		BARGB0,WREG
		ADDWF		REMB0,F

		BTFSC		_C		; test
		GOTO		D3216UQOK

		MOVFP		AARGB1,WREG
		MULWF		BARGB1

		MOVFP		PRODL,WREG
		SUBWF		TEMPB2,W
		MOVFP		PRODH,WREG
		SUBWFB		REMB0,W

		BTFSS		_C		; test
		DECF		AARGB1,F

D3216UQOK
		MOVFP		AARGB1,WREG
		MOVWF		ZARGB1

		MOVFP		AARGB1,WREG
		MULWF		BARGB1
		MOVFP		PRODL,WREG
		SUBWF		TEMPB2,F
		MOVFP		PRODH,WREG
		SUBWFB		TEMPB1,F

		MOVFP		AARGB1,WREG
		MULWF		BARGB0
		MOVFP		PRODL,WREG
		SUBWF		TEMPB1,F
		MOVFP		PRODH,WREG
		SUBWFB		TEMPB0,F

		BTFSS		TEMPB0,MSB
		GOTO		D3216QOK
		DECF		ZARGB1,F

		MOVFP		BARGB1,WREG
		ADDWF		TEMPB2,F
		MOVFP		BARGB0,WREG
		ADDWFC		TEMPB1,F

D3216QOK
		DCFSNZ		AEXP,F		; is loop done?
		GOTO		D3216FIXREM

		MOVFP		ZARGB2,WREG
		MOVWF		ZARGB3
		MOVFP		ZARGB1,WREG
		MOVWF		ZARGB2

		MOVFP		TEMPB1,WREG
		MOVWF		TEMPB0
		MOVFP		TEMPB2,WREG
		MOVWF		TEMPB1
		MOVFP		TEMPB3,WREG
		MOVWF		TEMPB2
		MOVFP		BEXP,WREG
		MOVWF		TEMPB3

		GOTO		D3216ULOOP		

D3216FIXREM
		MOVFP		TEMPB1,WREG
		MOVWF		REMB0
		MOVFP		TEMPB2,WREG
		MOVWF		REMB1

		MOVLW		0x01
		CPFSGT		ZARGB0
		GOTO		D3216REMOK
		RRNCF		ZARGB0,W
		MOVWF		BARGB0
		CALL		DGETNRMD

		MULWF		TEMPB2
		MOVPF		PRODH,REMB1
		MULWF		TEMPB1
		MOVPF		PRODL,WREG
		ADDWF		REMB1,F
		MOVPF		PRODH,REMB0

D3216REMOK
		CLRF		AARGB0,F
		MOVFP		ZARGB1,WREG
		MOVWF		AARGB3
		MOVFP		ZARGB2,WREG
		MOVWF		AARGB2
		MOVFP		ZARGB3,WREG
		MOVWF		AARGB1

		RETLW       0x00

		END
