;	RCS Header $Id: FXD3232S.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       32/32 Bit Signed Fixed Point Divide 32/32 -> 32.32

;       Input:  32 bit fixed point dividend in AARGB0, AARGB1, AARGB2
;               32 bit fixed point divisor in BARGB0, BARGB1

;       Use:    CALL    FXD3232S

;       Output: 32 bit fixed point quotient in AARGB0, AARGB1, AARGB2
;               32 bit fixed point remainder in REMB0, REMB1

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	32	410	127.22	clks

;       PM: 50             DM: 12

;----------------------------------------------------------------------------------------------

PROG	CODE

		EXTERN		FXD3232U

FXD3232S
		GLOBAL		FXD3232S

		CLRF		SIGN,W		; clear sign

        BTFSS       BARGB0,MSB
        GOTO        DA3232S

        COMF        BARGB3,F	; if BARG<0, negate and toggle sign
        COMF        BARGB2,F
        COMF        BARGB1,F
        COMF        BARGB0,F
        INCF		BARGB3,F
		ADDWFC		BARGB2,F
		ADDWFC		BARGB1,F
		ADDWFC		BARGB0,F
		COMF		SIGN,F

DA3232S
        BTFSS       AARGB0,MSB
        GOTO        D3232S

        COMF        AARGB3,F	; if AARG<0, negate and toggle sign
        COMF        AARGB2,F
        COMF        AARGB1,F
        COMF        AARGB0,F
        INCF        AARGB3,F
        ADDWFC      AARGB2,F
        ADDWFC      AARGB1,F
        ADDWFC      AARGB0,F
		COMF		SIGN,F

D3232S
		CALL		FXD3232U

		BTFSC		AARGB0,MSB	; test for exception
		GOTO		D3232SX

D3232SOK
		BTFSS       SIGN,MSB
        RETLW       0x00
D3232SNEG
        COMF        AARGB3,F	; negate if result negative
        COMF        AARGB2,F
        COMF        AARGB1,F
        COMF        AARGB0,F
        CLRF        WREG,F
        INCF        AARGB3,F
        ADDWFC      AARGB2,F
        ADDWFC      AARGB1,F
        ADDWFC      AARGB0,F

        COMF        REMB3,F
        COMF        REMB2,F
        COMF        REMB1,F
        COMF        REMB0,F
        INCF        REMB3,F
        ADDWFC      REMB2,F
        ADDWFC      REMB1,F
        ADDWFC      REMB0,F

        RETLW       0x00

D3232SX
		BTFSC		SIGN,MSB
		GOTO		D3232SNEG
		BSF			FPFLAGS,NAN	; NAN exception if AARG=0x800000
		RETLW		0xFF		; with positive sign

		END
