;	RCS Header $Id: FXD3232U.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       32/32 Bit Unsigned Fixed Point Divide 32/32 -> 32.32

;       Input:  32 bit unsigned fixed point dividend in AARGB0, AARGB1
;               32 bit unsigned fixed point divisor in BARGB0, BARGB1

;       Use:    CALL    FXD3232U

;       Output: 32 bit unsigned fixed point quotient in AARGB0, AARGB1
;               32 bit unsigned fixed point remainder in REMB0, REMB1

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	18	375	89.51	clks

;       PM: 157               DM: 24

;----------------------------------------------------------------------------------------------

PROG	CODE

		EXTERN		FXD3224U
		EXTERN		IBXTBL256
		EXTERN		FXD1608U1
		EXTERN		D3232QZERO

FXD3232U
		GLOBAL		FXD3232U

		TSTFSZ		BARGB0
		GOTO		D3232B0GT0
		MOVFP		BARGB1,WREG
		MOVWF		BARGB0
		MOVFP		BARGB2,WREG
		MOVWF		BARGB1
		MOVFP		BARGB3,WREG
		MOVWF		BARGB2
		CALL		FXD3224U
		MOVFP		REMB2,WREG
		MOVWF		REMB3
		MOVFP		REMB1,WREG
		MOVWF		REMB2
		MOVFP		REMB0,WREG
		MOVWF		REMB1
		CLRF		REMB0,F
		RETLW		0x00

D3232B0GT0
		MOVFP		BARGB0,WREG
		SUBWF		AARGB0,W
		BTFSS		_C
		GOTO		D3232QZERO
		BTFSS		_Z
		GOTO		D3232AGEB

		MOVFP		BARGB1,WREG
		SUBWF		AARGB1,W
		BTFSS		_C
		GOTO		D3232QZERO
		BTFSS		_Z
		GOTO		D3232AGEB

		MOVFP		BARGB2,WREG
		SUBWF		AARGB2,W
		BTFSS		_C
		GOTO		D3232QZERO
		BTFSS		_Z
		GOTO		D3232AGEB

		MOVFP		BARGB3,WREG
		SUBWF		AARGB3,W
		BTFSS		_C
		GOTO		D3232QZERO

D3232AGEB
		MOVFP		AARGB0,WREG
		MOVWF		TEMPB0
		MOVFP		AARGB1,WREG
		MOVWF		TEMPB1
		MOVFP		AARGB2,WREG
		MOVWF		TEMPB2
		MOVFP		AARGB3,WREG
		MOVWF		TEMPB3

		MOVFP		AARGB3,WREG
		MOVWF		BEXP
		MOVFP		AARGB2,WREG
		MOVWF		CARGB3
		MOVFP		AARGB1,WREG
		MOVWF		CARGB2
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1
		CLRF		AARGB0,F

		MOVFP		BARGB0,WREG
		MOVWF		ZARGB0
		MOVFP		BARGB1,WREG
		MOVWF		ZARGB1
		MOVFP		BARGB2,WREG
		MOVWF		ZARGB2
		MOVFP		BARGB3,WREG
		MOVWF		ZARGB3

		BTFSC		BARGB0,MSB
		GOTO		D3232UNRMOK

		MOVFP		BARGB0,WREG	; access reciprocal table
;		ADDLW		LOW (IBXTBL256) + 1
		ADDLW		LOW (IBXTBL256 + 1)
		MOVWF		TBLPTRL
		MOVLW		HIGH (IBXTBL256)
		CLRF		TBLPTRH,F
		ADDWFC		TBLPTRH,F
		TABLRD		0,1,WREG

		TLRD		1,WREG		; normalize
		MULWF		ZARGB3
		MOVPF		PRODL,BARGB3
		MOVPF		PRODH,BARGB2
		MULWF		ZARGB1
		MOVPF		PRODL,BARGB1
		MOVPF		PRODH,BARGB0
		MULWF		ZARGB2
		MOVPF		PRODL,WREG
		ADDWF		BARGB2,F
		MOVPF		PRODH,WREG
		ADDWFC		BARGB1,F
		CLRF		WREG,F
		ADDWFC		BARGB0,F
		TLRD		1,WREG
		MULWF		ZARGB0
		MOVFP		PRODL,WREG
		ADDWF		BARGB0,F

		TLRD		1,WREG
		MULWF		TEMPB3
		MOVPF		PRODL,BEXP
		MOVPF		PRODH,CARGB3
		MULWF		TEMPB1
		MOVPF		PRODL,CARGB2
		MOVPF		PRODH,AARGB1
		MULWF		TEMPB2
		MOVPF		PRODL,WREG
		ADDWF		CARGB3,F
		MOVPF		PRODH,WREG
		ADDWF		CARGB2,F
		CLRF		AARGB0,W
		ADDWFC		AARGB1,F
		ADDWFC		AARGB0,F

		TLRD		1,WREG
		MULWF		TEMPB0
		MOVFP		PRODL,WREG
		ADDWF		AARGB1,F
		MOVPF		PRODH,WREG
		ADDWFC		AARGB0,F

D3232UNRMOK
		CALL		FXD1608U1	; estimate quotient digit

		MOVFP		AARGB1,WREG
		MULWF		BARGB1

		MOVFP		PRODL,WREG
		SUBWF		CARGB2,W
		MOVFP		PRODH,WREG
		SUBWFB		REMB0,W

		BTFSS		_C		; test
		DECF		AARGB1,F

D3232UQOK
		MOVFP		AARGB1,WREG
		MULWF		ZARGB3
		MOVFP		PRODL,WREG
		SUBWF		TEMPB3,F
		MOVFP		PRODH,WREG
		SUBWFB		TEMPB2,F
		CLRF		WREG,F
		SUBWFB		TEMPB1,F
		SUBWFB		TEMPB0,F

		MOVFP		AARGB1,WREG
		MULWF		ZARGB2
		MOVFP		PRODL,WREG
		SUBWF		TEMPB2,F
		MOVFP		PRODH,WREG
		SUBWFB		TEMPB1,F
		CLRF		WREG,F
		SUBWFB		TEMPB0,F

		MOVFP		AARGB1,WREG
		MULWF		ZARGB1
		MOVFP		PRODL,WREG
		SUBWF		TEMPB1,F
		MOVFP		PRODH,WREG
		SUBWFB		TEMPB0,F

		MOVFP		AARGB1,WREG
		MULWF		ZARGB0
		MOVFP		PRODL,WREG
		SUBWF		TEMPB0,F

		BTFSS		TEMPB0,MSB	; test
		GOTO		D3232QOK
		DECF		AARGB1,F

		MOVFP		ZARGB3,WREG
		ADDWF		TEMPB3,F
		MOVFP		ZARGB2,WREG
		ADDWFC		TEMPB2,F
		MOVFP		ZARGB1,WREG
		ADDWFC		TEMPB1,F
		MOVFP		ZARGB0,WREG
		ADDWFC		TEMPB0,F

D3232QOK
		MOVFP		TEMPB0,WREG
		MOVWF		REMB0
		MOVFP		TEMPB1,WREG
		MOVWF		REMB1
		MOVFP		TEMPB2,WREG
		MOVWF		REMB2
		MOVFP		TEMPB3,WREG
		MOVWF		REMB3

		MOVFP		AARGB1,WREG
		MOVWF		AARGB3
		CLRF		AARGB2,F
		CLRF		AARGB1,F
		CLRF		AARGB0,F

        RETLW       0x00

		END
