;	RCS Header $Id: FXM0808S.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       8x8 Bit Signed Fixed Point Multiply 08 x 08 -> 16

;       Input:  8 bit signed fixed point multiplicand in AARGB0
;               8 bit signed fixed point multiplier in BARGB0

;       Use:    CALL    FXM0808S

;       Output: 16 bit signed fixed point product in AARGB0, AARGB1

;       Result: AARG  <--  AARG * BARG

;	Testing on [-0x7F,0x7F] from 100000 trials:

;		min	max	mean
;	Timing:	11	11	11.0	clks

;       PM: 10              DM: 3

PROG	CODE

FXM0808S
		GLOBAL	FXM0808S

		MOVFP	AARGB0,WREG
		MULWF	BARGB0
		BTFSC	BARGB0,MSB
		SUBWF	PRODH,F
		MOVFP	BARGB0,WREG
		BTFSC	AARGB0,MSB
		SUBWF	PRODH,F
		MOVPF	PRODH,AARGB0
		MOVPF	PRODL,AARGB1
		RETLW	0x00

		END


