;	RCS Header $Id: FXM1608S.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       16x8 bit unsigned fixed point multiply 16 x 08 -> 24

;       Input:  16 bit signed fixed point multiplicand in AARGB0
;               8 bit signed fixed point multiplier in BARGB0

;       Use:    CALL    FXM1608S

;       Output: 24 bit signed fixed point product in AARGB0, AARGB1

;       Result: AARG  <--  AARG * BARG

;	Testing on [-0x7FFF,0x7FFF], [-0x7F,0x7F] from 100000 trials:

;		min	max	mean
;	Timing:	18	21	19.5	clks

;       PM: 20              DM: 4

PROG	CODE

FXM1608S
		GLOBAL	FXM1608S

		MOVFP	AARGB1,WREG
		MOVWF	TEMP
		MOVFP	BARGB0,WREG
		MULWF	AARGB1
		MOVPF	PRODH,AARGB1
		MOVPF	PRODL,AARGB2
		MULWF	AARGB0
		BTFSC	AARGB0,MSB
		SUBWF	PRODH,F
		BTFSS	BARGB0,MSB
		GOTO	SIGN1608OK
		MOVFP	TEMP,WREG
		SUBWF	AARGB1,F
		MOVFP	AARGB0,WREG
		SUBWFB	PRODH,F

SIGN1608OK	CLRF	AARGB0,F
		MOVFP	PRODL,WREG
		ADDWF	AARGB1,F
		MOVFP	PRODH,WREG
		ADDWFC	AARGB0,F

		RETLW	0x00

		END

