;	RCS Header $Id: FXM1608U.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       16x8 Bit Unsigned Fixed Point Multiply 16 x 08 -> 24

;       Input:  16 bit unsigned fixed point multiplicand in AARGB0
;               8 bit unsigned fixed point multiplier in BARGB0

;       Use:    CALL    FXM1608U

;       Output: 24 bit unsigned fixed point product in AARGB0, AARGB1, AARGB2

;       Result: AARG  <--  AARG * BARG

;	Testing on [0x0000,0xFFFF], [0x00,0xFF] from 100000 trials:

;		min	max	mean
;	Timing:	11	11	11.0	clks

;       PM: 11              DM: 4

PROG	CODE

FXM1608U
		GLOBAL	FXM1608U

		MOVFP	BARGB0,WREG
		MULWF	AARGB1
		MOVPF	PRODH,AARGB1
		MOVPF	PRODL,AARGB2
		MULWF	AARGB0
		MOVPF	PRODH,AARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB1,F
		CLRF	WREG,F
		ADDWFC	AARGB0,F

		RETLW	0x00

		END

