;	RCS Header $Id: FXM1616S.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       16x16 Bit Signed Fixed Point Multiply 16 x 16 -> 32

;       Input:  16 bit signed fixed point multiplicand in AARGB0, AARGB1
;               16 bit signed fixed point multiplier in BARGB0, BARGB1

;       Use:    CALL    FXM1616S

;       Output: 32 bit signed fixed point product in AARGB0, AARGB1,
;               AARGB2, AARGB3

;       Result: AARG  <--  AARG * BARG

;	Testing on [-0x7FFF,0x7FFF] from 100000 trials:

;		min	max	mean
;	Timing:	31	39	35.0	clks

;       PM: 39              DM: 8

PROG	CODE

FXM1616S
		GLOBAL	FXM1616S

		MOVFP	AARGB0,WREG		; save AARG
		MOVWF	TEMPB0
		MOVFP	AARGB1,WREG
		MOVWF	TEMPB1	

		MULWF	BARGB1
		MOVPF	PRODH,AARGB2
		MOVPF	PRODL,AARGB3
		
		MOVFP	AARGB0,WREG
		MULWF	BARGB0
		MOVPF	PRODH,AARGB0
		MOVPF	PRODL,AARGB1

		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F
		CLRF	WREG,F
		ADDWFC	AARGB0,F

		MOVFP	TEMPB1,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F
		CLRF	WREG,F
		ADDWFC	AARGB0,F

		BTFSS	BARGB0,MSB			; sign corrections
		GOTO	TSIGN1616A
		MOVFP	TEMPB1,WREG
		SUBWF	AARGB1,F
		MOVFP	TEMPB0,WREG
		SUBWFB	AARGB0,F

TSIGN1616A
		BTFSS	TEMPB0,MSB
		RETLW	0x00
		MOVFP	BARGB1,WREG
		SUBWF	AARGB1,F
		MOVFP	BARGB0,WREG
		SUBWFB	AARGB0,F
		
		RETLW	0x00

		END


