;	RCS Header $Id: FXM1616U.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       16x16 Bit Unsigned Fixed Point Multiply 16 x 16 -> 32

;       Input:  16 bit unsigned fixed point multiplicand in AARGB0, AARGB1
;               16 bit unsigned fixed point multiplier in BARGB0, BARGB1

;       Use:    CALL    FXM1616U

;       Output: 32 bit unsigned fixed point product in AARGB0, AARGB1, 
;               AARGB2, AARGB3

;       Result: AARG  <--  AARG * BARG

;	Testing on [0x0000,0xFFFF], [0x00,0xFF] from 100000 trials:

;		min	max	mean
;	Timing:	25	25	25.0	clks

;       PM: 25              DM: 7

PROG	CODE

FXM1616U
		GLOBAL	FXM1616U

		MOVFP	AARGB1,WREG			; save AARGB1
		MOVWF	TEMPB1	

		MULWF	BARGB1
		MOVPF	PRODH,AARGB2
		MOVPF	PRODL,AARGB3
		
		MOVFP	AARGB0,WREG
		MULWF	BARGB0
		MOVPF	PRODH,AARGB0
		MOVPF	PRODL,AARGB1

		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F
		CLRF	WREG,F
		ADDWFC	AARGB0,F

		MOVFP	TEMPB1,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F
		CLRF	WREG,F
		ADDWFC	AARGB0,F
		
		RETLW	0x00

		END

