;	RCS Header $Id: FXM3216S.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       32x16 Bit Signed Fixed Point Multiply 32 x 16 -> 48

;       Input:  32 bit signed fixed point multiplicand in AARGB0, AARGB1,
;               AARGB2, AARGB3
;               16 bit signed fixed point multiplier in BARGB0, BARGB1

;       Use:    CALL    FXM3216S

;       Output: 48 bit signed fixed point product in AARGB0, AARGB1,
;               AARGB2, AARGB3, AARGB4, AARGB5

;       Result: AARG  <--  AARG * BARG

;	Testing on [-0x7FFFFFFF,0x7FFFFFFF], [-0x7FFF,0x7FFF] from 100000 trials:

;		min	max	mean
;	Timing:	63	75	69.0	clks

;       PM: 71              DM: 12

PROG	CODE

FXM3216S
		GLOBAL	FXM3216S

		MOVFP	AARGB0,WREG
		MOVWF	TEMPB0	
		MOVFP	AARGB1,WREG
		MOVWF	TEMPB1	
		MOVFP	AARGB2,WREG
		MOVWF	TEMPB2	
		MOVFP	AARGB3,WREG
		MOVWF	TEMPB3	

		MULWF	BARGB1
		MOVPF	PRODH,AARGB4
		MOVPF	PRODL,AARGB5
		
		MOVFP	AARGB2,WREG
		MULWF	BARGB0
		MOVPF	PRODH,AARGB2
		MOVPF	PRODL,AARGB3

		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F
		CLRF	WREG,F
		ADDWFC	AARGB2,F

		MOVFP	TEMPB3,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F
		CLRF	WREG,F
		ADDWFC	AARGB2,F
	
		MOVFP	AARGB1,WREG
		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB3,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB2,F
		MOVFP	AARGB1,WREG
		MULWF	BARGB0
		CLRF	AARGB1,W
		ADDWFC	AARGB1,F
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F

		MOVFP	AARGB0,WREG
		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F
		MOVFP	AARGB0,WREG
		MULWF	BARGB0
		CLRF	AARGB0,W
		ADDWFC	AARGB0,F
		MOVPF	PRODL,WREG
		ADDWF	AARGB1,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB0,F

		BTFSS	BARGB0,MSB
		GOTO	TSIGN3216A
		MOVFP	TEMPB3,WREG
		SUBWF	AARGB3,F
		MOVFP	TEMPB2,WREG
		SUBWFB	AARGB2,F
		MOVFP	TEMPB1,WREG
		SUBWFB	AARGB1,F
		MOVFP	TEMPB0,WREG
		SUBWFB	AARGB0,F

TSIGN3216A
		BTFSS	TEMPB0,MSB
		RETLW	0x00
		MOVFP	BARGB1,WREG
		SUBWF	AARGB1,F
		MOVFP	BARGB0,WREG
		SUBWFB	AARGB0,F

		RETLW	0x00

		END

