;	RCS Header $Id: FXM3216U.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       32x16 Bit Unsigned Fixed Point Multiply 32 x 16 -> 48

;       Input:  32 bit unsigned fixed point multiplicand in AARGB0, AARGB1,
;               AARGB2, AARGB3
;               16 bit unsigned fixed point multiplier in BARGB0, BARGB1

;       Use:    CALL    FXM3216U

;       Output: 48 bit unsigned fixed point product in AARGB0, AARGB1, 
;               AARGB2, AARGB3, AARGB4, AARGB5

;       Result: AARG  <--  AARG * BARG

;	Testing on [0x00000000,0xFFFFFFFF], [0x0000,0xFFFF] from 100000 trials:

;		min	max	mean
;	Timing:	53	53	53.0	clks

;       PM: 52              DM: 9

PROG	CODE

FXM3216U
		GLOBAL	FXM3216U

		MOVFP	AARGB3,WREG
		MOVWF	TEMPB3	

		MULWF	BARGB1
		MOVPF	PRODH,AARGB4
		MOVPF	PRODL,AARGB5
		
		MOVFP	AARGB2,WREG
		MULWF	BARGB0
		MOVPF	PRODH,AARGB2
		MOVPF	PRODL,AARGB3

		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F
		CLRF	WREG,F
		ADDWFC	AARGB2,F

		MOVFP	TEMPB3,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F
		CLRF	WREG,F
		ADDWFC	AARGB2,F
	
		MOVFP	AARGB1,WREG
		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB3,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB2,F
		MOVFP	AARGB1,WREG
		MULWF	BARGB0
		CLRF	AARGB1,W
		ADDWFC	AARGB1,F
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F

		MOVFP	AARGB0,WREG
		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F
		MOVFP	AARGB0,WREG
		MULWF	BARGB0
		CLRF	AARGB0,W
		ADDWFC	AARGB0,F
		MOVPF	PRODL,WREG
		ADDWF	AARGB1,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB0,F

		RETLW	0x00

		END

