;	RCS Header $Id: FXM3224U.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       32x24 Bit Unsigned Fixed Point Multiply 32 x 24 -> 56

;       Input:  32 bit unsigned fixed point multiplicand in AARGB0, AARGB1,
;               AARGB2, AARGB3
;               24 bit unsigned fixed point multiplier in BARGB0, BARGB1,
;               BARGB2

;       Use:    CALL    FXM3224U

;       Output: 56 bit unsigned fixed point product in AARGB0, AARGB1, 
;               AARGB2, AARGB3, AARGB4, AARGB5, AARGB6

;       Result: AARG  <--  AARG * BARG

;	Testing on [0x00000000,0xFFFFFFFF], [0x000000,0xFFFFFF] from 100000 trials:

;		min	max	mean
;	Timing:	91	91	91.0	clks

;       PM: 92              DM: 14

PROG	CODE

FXM3224U
		GLOBAL	FXM3224U

		MOVFP	AARGB0,WREG
		MOVWF	TEMPB0
		MOVFP	AARGB1,WREG
		MOVWF	TEMPB1	
		MOVFP	AARGB2,WREG
		MOVWF	TEMPB2	
		MOVFP	AARGB3,WREG
		MOVWF	TEMPB3	

		MULWF	BARGB2
		MOVPF	PRODH,AARGB5
		MOVPF	PRODL,AARGB6
		
		MOVFP	AARGB2,WREG
		MULWF	BARGB1
		MOVPF	PRODH,AARGB3
		MOVPF	PRODL,AARGB4

		MULWF	BARGB2
		MOVPF	PRODL,WREG
		ADDWF	AARGB5,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB4,F
		CLRF	WREG,F
		ADDWFC	AARGB3,F

		MOVFP	TEMPB3,WREG
		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB5,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB4,F
		CLRF	WREG,F
		ADDWFC	AARGB3,F
	
		MOVFP	AARGB1,WREG
		MULWF	BARGB2
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F
		MOVFP	AARGB1,WREG
		MULWF	BARGB1
		CLRF	AARGB2,W
		ADDWFC	AARGB2,F
		MOVPF	PRODL,WREG
		ADDWF	AARGB3,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB2,F

		MOVFP	TEMPB3,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F
		CLRF	AARGB1,W
		ADDWFC	AARGB2,F
		ADDWFC	AARGB1,F

		MOVFP	TEMPB2,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB3,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB2,F
		CLRF	WREG,F
		ADDWFC	AARGB1,F

		MOVFP	TEMPB1,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F

		MOVFP	AARGB0,WREG
		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F
		MOVFP	AARGB0,WREG
		MULWF	BARGB0
		CLRF	AARGB0,W
		ADDWFC	AARGB0,F
		MOVPF	PRODL,WREG
		ADDWF	AARGB1,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB0,F

		MOVFP	TEMPB0,WREG
		MULWF	BARGB2
		MOVPF	PRODL,WREG
		ADDWF	AARGB3,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB2,F
		CLRF	WREG,F
		ADDWFC	AARGB1,F
		ADDWFC	AARGB0,F

		RETLW   0x00

		END

