;	RCS Header $Id: FXM3232S.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       32x32 Bit Signed Fixed Point Multiply 32 x 32 -> 64

;       Input:  32 bit signed fixed point multiplicand in AARGB0, AARGB1,
;               AARGB2, AARGB3
;               32 bit signed fixed point multiplier in BARGB0, BARGB1,
;               BARGB2, BARGB3

;       Use:    CALL    FXM3232S

;       Output: 64 bit signed fixed point product in AARGB0, AARGB1,
;               AARGB2, AARGB3, AARGB4, AARGB5, AARGB6, AARGB7

;       Result: AARG  <--  AARG * BARG

;	Testing on [-0x7FFFFFFF,0x7FFFFFFF] from 100000 trials:

;		min	max	mean
;	Timing:	129	145	137.0	clks

;       PM: 145              DM: 16

PROG	CODE

FXM3232S
		GLOBAL	FXM3232S

		MOVFP	AARGB0,WREG			; save AARG
		MOVWF	TEMPB0
		MOVFP	AARGB1,WREG
		MOVWF	TEMPB1	
		MOVFP	AARGB2,WREG
		MOVWF	TEMPB2	
		MOVFP	AARGB3,WREG
		MOVWF	TEMPB3	

		MULWF	BARGB3
		MOVPF	PRODL,AARGB7
		MOVPF	PRODH,AARGB6
		
		MOVFP	AARGB2,WREG
		MULWF	BARGB2
		MOVPF	PRODL,AARGB5
		MOVPF	PRODH,AARGB4

		MULWF	BARGB3
		MOVPF	PRODL,WREG
		ADDWF	AARGB6,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB5,F
		CLRF	WREG,F
		ADDWFC	AARGB4,F

		MOVFP	TEMPB3,WREG
		MULWF	BARGB2
		MOVPF	PRODL,WREG
		ADDWF	AARGB6,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB5,F
		CLRF	WREG,F
		ADDWFC	AARGB4,F
	
		MOVFP	AARGB1,WREG
		MULWF	BARGB3
		MOVPF	PRODL,WREG
		ADDWF	AARGB5,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB4,F
		MOVFP	AARGB1,WREG
		MULWF	BARGB2
		CLRF	AARGB3,W
		ADDWFC	AARGB3,F
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F

		MOVFP	TEMPB3,WREG
		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB5,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB4,F
		CLRF	AARGB2,W
		ADDWFC	AARGB3,F
		ADDWFC	AARGB2,F

		MOVFP	TEMPB2,WREG
		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F
		CLRF	WREG,F
		ADDWFC	AARGB2,F

		MOVFP	TEMPB1,WREG
		MULWF	BARGB1
		MOVPF	PRODL,WREG
		ADDWF	AARGB3,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB2,F

		MOVFP	AARGB0,WREG
		MULWF	BARGB2
		MOVPF	PRODL,WREG
		ADDWF	AARGB3,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB2,F
		MOVFP	AARGB0,WREG
		MULWF	BARGB1
		CLRF	AARGB1,W
		ADDWFC	AARGB1,F
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F

		MOVFP	TEMPB0,WREG
		MULWF	BARGB3
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F
		CLRF	WREG,F
		ADDWFC	AARGB2,F
		ADDWFC	AARGB1,F

		MOVFP	TEMPB0,WREG
		MULWF	BARGB0
		MOVPF	PRODH,AARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB1,F
		CLRF	WREG,F
		ADDWFC	AARGB0,F

		MOVFP	TEMPB3,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB4,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB3,F
		CLRF	WREG,F
		ADDWFC	AARGB2,F
		ADDWFC	AARGB1,F
		ADDWFC	AARGB0,F

		MOVFP	TEMPB2,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB3,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB2,F
		CLRF	WREG,F
		ADDWFC	AARGB1,F
		ADDWFC	AARGB0,F

		MOVFP	TEMPB1,WREG
		MULWF	BARGB0
		MOVPF	PRODL,WREG
		ADDWF	AARGB2,F
		MOVPF	PRODH,WREG
		ADDWFC	AARGB1,F
		CLRF	WREG,F
		ADDWFC	AARGB0,F

		BTFSS	BARGB0,MSB			; sign corrections
		GOTO	TSIGN3232A
		MOVFP	TEMPB3,WREG
		SUBWF	AARGB3,F
		MOVFP	TEMPB2,WREG
		SUBWFB	AARGB2,F
		MOVFP	TEMPB1,WREG
		SUBWFB	AARGB1,F
		MOVFP	TEMPB0,WREG
		SUBWFB	AARGB0,F

TSIGN3232A	BTFSS	TEMPB0,MSB
		RETLW	0x00
		MOVFP	BARGB3,WREG
		SUBWF	AARGB3,F
		MOVFP	BARGB2,WREG
		SUBWFB	AARGB2,F
		MOVFP	BARGB1,WREG
		SUBWFB	AARGB1,F
		MOVFP	BARGB0,WREG
		SUBWFB	AARGB0,F

		RETLW	0x00

		END

