;   RCS Header $Id: HANDLERS.ASM,v 1.1 1999/01/08 19:56:36 GrosbaJ Exp $

;   $Revision: 1.1 $

;   Error handlers and utility routines

; NOTE: All PAGESEL and BANKSEL instructions should have been generated by
;       the calling routines for these handlers.
;**********************************************************************************************

        #include    "cmath17.inc"

WREG        EQU     H'0A'

HANDLERS_CODE  CODE

SETIOV3232  
        GLOBAL      SETIOV3232

        BSF             FPFLAGS,IOV             ; set integer overflow flag
                BTFSS           FPFLAGS,SAT             ; test for saturation
                RETLW           0xFF                    ; return error code in WREG

                CLRF            AARGB0,F                ; saturate to largest two's
                BTFSS           SIGN,MSB                ; complement 32 bit integer
                SETF            AARGB0,F                ; SIGN = 0, 0x7FFFFFFF
                MOVFP           AARGB0,WREG
        MOVWF       AARGB1          ; SIGN = 1, 0x80000000
                MOVFP           AARGB0,WREG
        MOVWF       AARGB2
                MOVFP           AARGB0,WREG
        MOVWF       AARGB3
                RLCF            SIGN,F
                RRCF            AARGB0,F
                RETLW           0xFF                    ; return error code in WREG

;**********************************************************************************************

SETIOV3216  
        GLOBAL      SETIOV3216

        BSF             FPFLAGS,IOV             ; set integer overflow flag
                BTFSS           FPFLAGS,SAT             ; test for saturation
                RETLW           0xFF                    ; return error code in WREG

                CLRF            AARGB0,F                ; saturate to largest two's
                BTFSS           SIGN,MSB                ; complement 16 bit integer
                SETF            AARGB0,F                ; SIGN = 0, 0x7FFF
                MOVFP           AARGB0,WREG
        MOVWF       AARGB1          ; SIGN = 1, 0x8000
        RLCF            SIGN,F
                RRCF            AARGB0,F
                RETLW           0xFF                    ; return error code in WREG

;**********************************************************************************************

SETIOV3208  
        GLOBAL      SETIOV3208

        BSF             FPFLAGS,IOV             ; set integer overflow flag
                BTFSS           FPFLAGS,SAT             ; test for saturation
                RETLW           0xFF                    ; return error code in WREG

                CLRF            AARGB0,F                ; saturate to largest two's
                BTFSS           SIGN,MSB                ; complement 16 bit integer
                SETF            AARGB0,F                ; SIGN = 0, 0x7F
        RLCF            SIGN,F          ; SIGN = 1, 0x80
                RRCF            AARGB0,F
                RETLW           0xFF                    ; return error code in WREG

;**********************************************************************************************

SETFOV32        
        GLOBAL      SETFOV32

        BSF             FPFLAGS,FOV             ; set floating point overflow flag
                BTFSS           FPFLAGS,SAT             ; test for saturation
                RETLW           0xFF                    ; return error code in WREG

                SETF            AEXP,F          ; saturate to largest floating
                SETF            AARGB0,F                ; point number = 0xFF7FFFFF
                SETF            AARGB1,F        ; modulo the appropriate sign bit
                SETF            AARGB2,F
                RLCF            SIGN,F
                RRCF            AARGB0,F
                RETLW           0xFF                    ; return error code in WREG

;**********************************************************************************************

SETFUN32        
        GLOBAL      SETFUN32

        BSF             FPFLAGS,FUN             ; set floating point underflow flag
                BTFSS           FPFLAGS,SAT             ; test for saturation
                RETLW           0xFF                    ; return error code in WREG

                MOVLW           0x01                    ; saturate to smallest floating
                MOVPF           WREG,AEXP               ; point number = 0x01000000
                CLRF            AARGB0,F        ; modulo the appropriate sign bit
                CLRF            AARGB1,F
                CLRF            AARGB2,F
                RLCF            SIGN,F
                RRCF            AARGB0,F
                RETLW           0xFF                    ; return error code in WREG

;**********************************************************************************************

SETFDZ32        
        GLOBAL      SETFDZ32

        BSF             FPFLAGS,FDZ             ; set floating point divide by zero
                RETLW           0xFF                    ; flag and return error code in WREG

;**********************************************************************************************

RES032          
        GLOBAL      RES032

        CLRF            AARGB0,F        ; result equals zero
                CLRF            AARGB1,F
                CLRF            AARGB2,F
        CLRF        AARGB3,F        ; clear extended byte
                CLRF            EXP,F
                RETLW           0x00

;**********************************************************************************************

FIXSIGN32       
        GLOBAL      FIXSIGN32

        BTFSS           SIGN,MSB
                BCF             AARGB0,MSB      ; clear explicit MSB if positive
                RETLW           0x00


        END
