;	RCS Header $Id: RAND32.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;	Evaluate rand(x)

;	Input:	32 bit initial integer seed in RANDB0, RANDB1, RANDB2, RANDB3

;	Use:	CALL	RAND32

;	Output:	32 bit random integer in RANDB0, RANDB1, RANDB2, RANDB3

;	Result:	RAND  <--  RAND32( RAND )

;	Timing:	8+6+2+90+19 = 125 clks

;----------------------------------------------------------------------------------------------

;	Linear congruential random number generator

;		X <- (a * X + c) mod m

;	The calculation is performed exactly, with multiplier a, increment c, and
;	modulus m, selected to achieve high ratings from standard spectral tests.
;	The dedicated storage in RANDBx retains the current number in the sequence
;	and is not used by any other routine in the library. The initial seed, X0,
;	is arbitrary and must be placed in RANDBx.

PROG	CODE

RAND32
		GLOBAL	RAND32
		EXTERN	FXM3224U

		MOVFP		RANDB0,WREG
		MOVWF		AARGB0
		MOVFP		RANDB1,WREG
		MOVWF		AARGB1
		MOVFP		RANDB2,WREG
		MOVWF		AARGB2
		MOVFP		RANDB3,WREG
		MOVWF		AARGB3

		MOVLW		0x0D			; multiplier a = 1664525
		MOVWF		BARGB2
		MOVLW		0x66
		MOVWF		BARGB1
		MOVLW		0x19
		MOVWF		BARGB0

		CALL		FXM3224U

		MOVLW		0x01			; increment c = 1
		ADDWF		AARGB6,F
		CLRF		WREG,F
		ADDWFC		AARGB5,F
		ADDWFC		AARGB4,F
		ADDWFC		AARGB3,F
		ADDWFC		AARGB2,F
		ADDWFC		AARGB1,F
		ADDWFC		AARGB0,F

		MOVFP		AARGB3,WREG
		MOVWF		RANDB0			; modulus m = 2**32
		MOVFP		AARGB4,WREG
		MOVWF		RANDB1
		MOVFP		AARGB5,WREG
		MOVWF		RANDB2
		MOVFP		AARGB6,WREG
		MOVWF		RANDB3

		RETLW		0x00

		END

