;	RCS Header $Id: TAGEB32.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;	Floating Point Relation	A >= B

;	Input:	32 bit floating point number in AEXP, AARGB0, AARGB1, AARGB2
;		32 bit floating point number in BEXP, BARGB0, BARGB1, BARGB2

;	Use:	CALL	TAGEB32

;	Output:	logical result in WREG

;	Testing on [-MAXNUM,MAXNUM] from 100000 trials:

;	Result:	if A >= B TRUE,	 WREG = 0x01
;		if A >= B FALSE, WREG = 0x00

;		min	max	mean
;	Timing:	8	31	11.6	clks

PROG	CODE

TAGEB32
		GLOBAL		TAGEB32

		MOVFP		BARGB0,WREG
		XORWF		AARGB0,W
		BTFSC		WREG,MSB
		GOTO		TAGEB32O

		BTFSC		BARGB0,MSB
		GOTO		TAGEB32N

TAGEB32P
		MOVFP		BEXP,WREG
		SUBWF		AEXP,W
		BTFSS		_C
		RETLW		0x00
		BTFSS		_Z
		RETLW		0x01

		MOVFP		BARGB0,WREG
		SUBWF		AARGB0,W
		BTFSS		_C
		RETLW		0x00
		BTFSS		_Z
		RETLW		0x01

		MOVFP		BARGB1,WREG
		SUBWF		AARGB1,W
		BTFSS		_C
		RETLW		0x00
		BTFSS		_Z
		RETLW		0x01

		MOVFP		BARGB2,WREG
		SUBWF		AARGB2,W
		BTFSS		_C
		RETLW		0x00
		RETLW		0x01

TAGEB32N
		MOVFP		AEXP,WREG
		SUBWF		BEXP,W
		BTFSS		_C
		RETLW		0x00
		BTFSS		_Z
		RETLW		0x01

		MOVFP		AARGB0,WREG
		SUBWF		BARGB0,W
		BTFSS		_C
		RETLW		0x00
		BTFSS		_Z
		RETLW		0x01

		MOVFP		AARGB1,WREG
		SUBWF		BARGB1,W
		BTFSS		_C
		RETLW		0x00
		BTFSS		_Z
		RETLW		0x01

		MOVFP		AARGB2,WREG
		SUBWF		BARGB2,W
		BTFSS		_C
		RETLW		0x00
		RETLW		0x01

TAGEB32O
		BTFSS		AARGB0,MSB
		RETLW		0x01
		RETLW		0x00

		END

