;	RCS Header $Id: TANEB32.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;	Floating Point Relation	A =! B

;	Input:	32 bit floating point number in AEXP, AARGB0, AARGB1, AARGB2
;		32 bit floating point number in BEXP, BARGB0, BARGB1, BARGB2

;	Use:	CALL	TANEB32

;	Output:	logical result in WREG

;	Testing on [-MAXNUM,MAXNUM] from 100000 trials:

;	Result:	if A =! B TRUE,	 WREG = 0x01
;		if A =! B FALSE, WREG = 0x00

;		min	max	mean
;	Timing:	4	14	5.9	clks

PROG	CODE

TANEB32
		GLOBAL		TANEB32

		MOVFP		AEXP,WREG
		CPFSEQ		BEXP
		RETLW		0x01
		MOVFP		AARGB0,WREG
		CPFSEQ		BARGB0
		RETLW		0x01
		MOVFP		AARGB1,WREG
		CPFSEQ		BARGB1
		RETLW		0x01
		MOVFP		AARGB2,WREG
		CPFSEQ		BARGB2
		RETLW		0x01
		RETLW		0x00

		END

