;	RCS Header $Id: util24.asm 1.1 1999-06-05 17:37:14-04 f_j_testa Exp f_j_testa $

;	$Revision: 1.1 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;	Error handlers and utility routines

PROG	CODE

;**********************************************************************************************

SETIOV2424
		GLOBAL		SETIOV2424

		BSF  		FPFLAGS,IOV  			; set integer overflow flag
		BTFSS		FPFLAGS,SAT  			; test for saturation
		RETLW		0xFF         			; return error code in WREG

		CLRF 		AARGB0,F     			; saturate to largest two's
		BTFSS		SIGN,MSB     			; complement 24 bit integer
		SETF 		AARGB0,F     			; SIGN = 0, 0x 7F FF FF
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1					; SIGN = 1, 0x 80 00 00
		MOVFP		AARGB0,WREG
		MOVWF		AARGB2
		RLCF 		SIGN,F
		RRCF 		AARGB0,F
		RETLW		0xFF         			; return error code in WREG

;**********************************************************************************************

SETIOV2416
		GLOBAL		SETIOV2416

		BSF  		FPFLAGS,IOV  			; set integer overflow flag
		BTFSS		FPFLAGS,SAT  			; test for saturation
		RETLW		0xFF         			; return error code in WREG

		CLRF 		AARGB0,F     			; saturate to largest two's
		BTFSS		SIGN,MSB     			; complement 16 bit integer
		SETF 		AARGB0,F     			; SIGN = 0, 0x 7F FF
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1					; SIGN = 1, 0x 80 00
		RLCF 		SIGN,F
		RRCF 		AARGB0,F
		RETLW		0xFF         			; return error code in WREG

;**********************************************************************************************

SETIOV2408
		GLOBAL		SETIOV2408

		BSF  		FPFLAGS,IOV             ; set integer overflow flag
		BTFSS		FPFLAGS,SAT             ; test for saturation
		RETLW		0xFF                    ; return error code in WREG

		CLRF 		AARGB0,F                ; saturate to largest two's
		BTFSS		SIGN,MSB                ; complement 16 bit integer
		SETF 		AARGB0,F                ; SIGN = 0, 0x7F
		RLCF 		SIGN,F					; SIGN = 1, 0x80
		RRCF 		AARGB0,F
		RETLW		0xFF                    ; return error code in WREG

;**********************************************************************************************

SETFOV24
		GLOBAL		SETFOV24

		BSF  		FPFLAGS,FOV		; set floating point underflag
		BTFSS		FPFLAGS,SAT             ; test for saturation
		RETLW		0xFF                    ; return error code in WREG

		SETF 		AEXP,F			; saturate to largest floating
		SETF 		AARGB0,F		; point number = 0x FF 7F FF
		SETF 		AARGB1,F		; modulo the appropriate sign bit
		RLCF 		SIGN,F
		RRCF 		AARGB0,F
		RETLW		0xFF			; return error code in WREG

;**********************************************************************************************

SETFUN24
		GLOBAL		SETFUN24

		BSF  		FPFLAGS,FUN			; set floating point underflag
		BTFSS		FPFLAGS,SAT			; test for saturation
		RETLW		0xFF       			; return error code in WREG

		MOVLW		0x01       			; saturate to smallest floating
		MOVWF		AEXP  			; point number = 0x 01 00 00
		CLRF 		AARGB0,F   			; modulo the appropriate sign bit
		CLRF 		AARGB1,F
		RLCF 		SIGN,F
		RRCF 		AARGB0,F
		RETLW		0xFF       			; return error code in WREG

;**********************************************************************************************

SETFDZ24
		GLOBAL		SETFDZ24

		BSF  		FPFLAGS,FDZ             ; set floating point divide by zero
		RETLW		0xFF                    ; flag and return error code in 
                                                        ; WREG
;**********************************************************************************************

RES024
		GLOBAL		RES024

		CLRF  		AARGB0,F			; result equals zero
		CLRF  		AARGB1,F
		CLRF  		AARGB2,F			; clear extended byte
		CLRF  		AEXP,F
		RETLW 		0

;**********************************************************************************************

FIXSIGN24
		GLOBAL		FIXSIGN24

		BTFSS		SIGN,MSB
		BCF  		AARGB0,MSB	   		; clear explicit MSB if positive
		RETLW		0

;**********************************************************************************************

		END
