;	RCS Header $Id: util32.asm 1.1 1999-05-30 22:02:19-04 f_j_testa Exp f_j_testa $

;	$Revision: 1.1 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;	Error handlers and utility routines

PROG	CODE

;**********************************************************************************************

SETIOV3232
		GLOBAL		SETIOV3232

		BSF  		FPFLAGS,IOV             ; set integer overflow flag
		BTFSS		FPFLAGS,SAT             ; test for saturation
		RETLW		0xFF                    ; return error code in WREG

		CLRF 		AARGB0,F                ; saturate to largest two's
		BTFSS		SIGN,MSB                ; complement 32 bit integer
		SETF 		AARGB0,F                ; SIGN = 0, 0x7FFFFFFF
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1					; SIGN = 1, 0x80000000
		MOVFP		AARGB0,WREG
		MOVWF		AARGB2
		MOVFP		AARGB0,WREG
		MOVWF		AARGB3
		RLCF 		SIGN,F
		RRCF 		AARGB0,F
		RETLW		0xFF                    ; return error code in WREG

;**********************************************************************************************

SETIOV3224
		GLOBAL		SETIOV3224

		BSF  		FPFLAGS,IOV             ; set integer overflow flag
		BTFSS		FPFLAGS,SAT             ; test for saturation
		RETLW		0xFF                    ; return error code in WREG

		CLRF 		AARGB0,F                ; saturate to largest two's
		BTFSS		SIGN,MSB                ; complement 24 bit integer
		SETF 		AARGB0,F                ; SIGN = 0, 0x 7F FF FF
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1					; SIGN = 1, 0x 80 00 00
		MOVFP		AARGB0,WREG
		MOVWF		AARGB2
		RLCF 		SIGN,F
		RRCF 		AARGB0,F
		RETLW		0xFF                    ; return error code in WREG

;**********************************************************************************************

SETIOV3216
		GLOBAL		SETIOV3216

		BSF  		FPFLAGS,IOV             ; set integer overflow flag
		BTFSS		FPFLAGS,SAT             ; test for saturation
		RETLW		0xFF                    ; return error code in WREG

		CLRF 		AARGB0,F                ; saturate to largest two's
		BTFSS		SIGN,MSB                ; complement 16 bit integer
		SETF 		AARGB0,F                ; SIGN = 0, 0x7FFF
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1			; SIGN = 1, 0x8000
		RLCF 		SIGN,F
		RRCF 		AARGB0,F
		RETLW		0xFF                    ; return error code in WREG

;**********************************************************************************************

SETIOV3208
		GLOBAL		SETIOV3208

		BSF  		FPFLAGS,IOV             ; set integer overflow flag
		BTFSS		FPFLAGS,SAT             ; test for saturation
		RETLW		0xFF                    ; return error code in WREG

		CLRF 		AARGB0,F                ; saturate to largest two's
		BTFSS		SIGN,MSB                ; complement 16 bit integer
		SETF 		AARGB0,F                ; SIGN = 0, 0x7F
		RLCF 		SIGN,F			; SIGN = 1, 0x80
		RRCF 		AARGB0,F
		RETLW		0xFF                    ; return error code in WREG

;**********************************************************************************************

SETFOV32
		GLOBAL		SETFOV32

		BSF  		FPFLAGS,FOV             ; set floating point underflag
		BTFSS		FPFLAGS,SAT             ; test for saturation
		RETLW		0xFF                    ; return error code in WREG

		SETF 		AEXP,F			; saturate to largest floating
		SETF 		AARGB0,F                ; point number = 0x FF 7F FF FF
		SETF 		AARGB1,F		; modulo the appropriate sign bit
		SETF 		AARGB2,F
		RLCF 		SIGN,F
		RRCF 		AARGB0,F
		RETLW		0xFF                    ; return error code in WREG

;**********************************************************************************************

SETFUN32
		GLOBAL		SETFUN32

		BSF  		FPFLAGS,FUN             ; set floating point underflag
		BTFSS		FPFLAGS,SAT             ; test for saturation
		RETLW		0xFF                    ; return error code in WREG

		MOVLW		0x01                    ; saturate to smallest floating
		MOVPF		WREG,AEXP               ; point number = 0x 01 00 00 00
		CLRF 		AARGB0,F		; modulo the appropriate sign bit
		CLRF 		AARGB1,F
		CLRF 		AARGB2,F
		RLCF 		SIGN,F
		RRCF 		AARGB0,F
		RETLW		0xFF                    ; return error code in WREG

;**********************************************************************************************


SETFDZ32
		GLOBAL		SETFDZ32

		BSF  		FPFLAGS,FDZ             ; set floating point divide by zero
		RETLW		0xFF                    ; flag and return error code in WREG

;**********************************************************************************************

RES032
		GLOBAL		RES032

		CLRF 		AARGB0,F		; result equals zero
		CLRF 		AARGB1,F
		CLRF 		AARGB2,F
		CLRF 		AARGB3,F		; clear extended byte
		CLRF 		AEXP,F
		RETLW		0

;**********************************************************************************************

FIXSIGN32
		GLOBAL		FIXSIGN32

		BTFSS		SIGN,MSB
		BCF  		AARGB0,MSB		; clear explicit MSB if positive
		RETLW		0x00

		END
