;	RCS Header $Id: fxd2408u.asm,v 1.1 2000/03/14 20:38:58 krt Exp $

;	$Revision: 1.1 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       24/08 Bit Unsigned Fixed Point Divide 24/08 -> 24.08

;       Input:  24 bit unsigned fixed point dividend in AARGB0, AARGB1, AARGB2
;               8 bit unsigned fixed point divisor in BARGB0

;       Use:    CALL    FXD2408U

;       Output: 24 bit unsigned fixed point quotient in AARGB0, AARGB1, AARGB2
;               8 bit unsigned fixed point remainder in REMB0

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	30	126	116.14	clks

;       PM: 13               DM: 8

;----------------------------------------------------------------------------------------------

PROG	CODE

		EXTERN		FXD1608U

FXD2408U
		GLOBAL		FXD2408U

		MOVFP		AARGB0,WREG
		MOVWF		TEMPB0
		MOVFP		AARGB1,WREG
		MOVWF		TEMPB1
		MOVFP		AARGB2,WREG
		MOVWF		TEMPB2

		CALL		FXD1608U

		MOVFP		AARGB0,WREG
		MOVWF		TEMPB0
		MOVFP		AARGB1,WREG
		MOVWF		TEMPB1

		MOVFP		TEMPB2,WREG
		MOVWF		AARGB1
		MOVFP		REMB0,WREG
		MOVWF		AARGB0

		CALL		FXD1608U

		MOVFP		AARGB1,WREG
		MOVWF		AARGB2
		MOVFP		TEMPB1,WREG
		MOVWF		AARGB1
		MOVFP		TEMPB0,WREG
		MOVWF		AARGB0

        RETLW           0x00

		END