;	RCS Header $Id: fxd2424u.asm,v 1.1 2000/03/14 20:33:14 krt Exp $

;	$Revision: 1.1 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       24/24 Bit Unsigned Fixed Point Divide 24/24 -> 24.24

;       Input:  24 bit unsigned fixed point dividend in AARGB0, AARGB1
;               24 bit unsigned fixed point divisor in BARGB0, BARGB1

;       Use:    CALL    FXD2424U

;       Output: 24 bit unsigned fixed point quotient in AARGB0, AARGB1
;               24 bit unsigned fixed point remainder in REMB0, REMB1

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	16	283	78.44	clks

;       PM: 123               DM: 17

;----------------------------------------------------------------------------------------------

PROG	CODE

		EXTERN		FXD2416U
		EXTERN		FXD1608U1
		EXTERN		IBXTBL256
		EXTERN		D2424QZERO

FXD2424U
		GLOBAL		FXD2424U

		TSTFSZ		BARGB0
		GOTO		D2424B0GT0
		MOVFP		BARGB1,WREG
		MOVWF		BARGB0
		MOVFP		BARGB2,WREG
		MOVWF		BARGB1
		CALL		FXD2416U
		MOVFP		REMB1,WREG
		MOVWF		REMB2
		MOVFP		REMB0,WREG
		MOVWF		REMB1
		CLRF		REMB0,F
		RETLW		0x00

D2424B0GT0
		MOVFP		BARGB0,WREG
		SUBWF		AARGB0,W
		BTFSS		_C
		GOTO		D2424QZERO
		BTFSS		_Z
		GOTO		D2424AGEB

		MOVFP		BARGB1,WREG
		SUBWF		AARGB1,W
		BTFSS		_C
		GOTO		D2424QZERO
		BTFSS		_Z
		GOTO		D2424AGEB

		MOVFP		BARGB2,WREG
		SUBWF		AARGB2,W
		BTFSS		_C
		GOTO		D2424QZERO

D2424AGEB
		MOVFP		AARGB0,WREG
		MOVWF		TEMPB0
		MOVFP		AARGB1,WREG
		MOVWF		TEMPB1
		MOVFP		AARGB2,WREG
		MOVWF		TEMPB2

		MOVFP		AARGB2,WREG
		MOVWF		CARGB3
		MOVFP		AARGB1,WREG
		MOVWF		CARGB2
		MOVFP		AARGB0,WREG
		MOVWF		AARGB1
		CLRF		AARGB0,F

		MOVFP		BARGB0,WREG
		MOVWF		ZARGB0
		MOVFP		BARGB1,WREG
		MOVWF		ZARGB1
		MOVFP		BARGB2,WREG
		MOVWF		ZARGB2

		BTFSC		BARGB0,MSB
		GOTO		D2424UNRMOK

		MOVFP		BARGB0,WREG	; access reciprocal table
;		ADDLW		LOW (IBXTBL256) + 1
		ADDLW		LOW (IBXTBL256 + 1)
		MOVWF		TBLPTRL
		MOVLW		HIGH (IBXTBL256)
		CLRF		TBLPTRH,F
		ADDWFC		TBLPTRH,F
		TABLRD		0,1,WREG

		TLRD		1,WREG		; normalize
		MULWF		ZARGB2
		MOVPF		PRODL,BARGB2
		MOVPF		PRODH,BARGB1
		MULWF		ZARGB1
		MOVFP		PRODL,WREG
		ADDWF		BARGB1,F
		CLRF		BARGB0,F
		MOVFP		PRODH,WREG
		ADDWFC		BARGB0,F
		TLRD		1,WREG
		MULWF		ZARGB0
		MOVFP		PRODL,WREG
		ADDWF		BARGB0,F

		TLRD		1,WREG
		MULWF		TEMPB2
		MOVPF		PRODL,CARGB3
		MOVPF		PRODH,CARGB2
		MULWF		TEMPB1
		MOVPF		PRODL,WREG
		ADDWF		CARGB2,F
		MOVPF		PRODH,AARGB1
		CLRF		AARGB0,F
		CLRF		WREG,F
		ADDWFC		AARGB1,F
		ADDWFC		AARGB0,F

		TLRD		1,WREG
		MULWF		TEMPB0
		MOVFP		PRODL,WREG
		ADDWF		AARGB1,F
		MOVPF		PRODH,WREG
		ADDWFC		AARGB0,F

D2424UNRMOK
		CALL		FXD1608U1	; estimate quotient digit

		MOVFP		AARGB1,WREG
		MULWF		BARGB1

		MOVFP		PRODL,WREG
		SUBWF		CARGB2,W
		MOVFP		PRODH,WREG
		SUBWFB		REMB0,W

		BTFSS		_C		; test
		DECF		AARGB1,F

D2424UQOK
		MOVFP		AARGB1,WREG
		MULWF		ZARGB2
		MOVFP		PRODL,WREG
		SUBWF		TEMPB2,F
		MOVFP		PRODH,WREG
		SUBWFB		TEMPB1,F
		CLRF		WREG,F
		SUBWFB		TEMPB0,F

		MOVFP		AARGB1,WREG
		MULWF		ZARGB1
		MOVFP		PRODL,WREG
		SUBWF		TEMPB1,F
		MOVFP		PRODH,WREG
		SUBWFB		TEMPB0,F

		MOVFP		AARGB1,WREG
		MULWF		ZARGB0
		MOVFP		PRODL,WREG
		SUBWF		TEMPB0,F

		BTFSS		TEMPB0,MSB	; test
		GOTO		D2424QOK
		DECF		AARGB1,F

		MOVFP		ZARGB2,WREG
		ADDWF		TEMPB2,F
		MOVFP		ZARGB1,WREG
		ADDWFC		TEMPB1,F
		MOVFP		ZARGB0,WREG
		ADDWFC		TEMPB0,F

D2424QOK
		MOVFP		TEMPB0,WREG
		MOVWF		REMB0
		MOVFP		TEMPB1,WREG
		MOVWF		REMB1
		MOVFP		TEMPB2,WREG
		MOVWF		REMB2

		MOVFP		AARGB1,WREG
		MOVWF		AARGB2
		CLRF		AARGB1,F
		CLRF		AARGB0,F

        RETLW       0x00

		END
