;	RCS Header $Id: fxd3208u.asm,v 1.1 2000/03/14 20:41:26 krt Exp $

;	$Revision: 1.1 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       32/08 Bit Unsigned Fixed Point Divide 32/08 -> 32.08

;       Input:  32 bit unsigned fixed point dividend in AARGB0, AARGB1, AARGB2, AARGB3
;               8 bit unsigned fixed point divisor in BARGB0

;       Use:    CALL    FXD3208U

;       Output: 32 bit unsigned fixed point quotient in AARGB0, AARGB1, AARGB2, AARGB3
;               8 bit unsigned fixed point remainder in REMB0

;       Result: AARG, REM  <--  AARG / BARG

;	Testing from 100000 trials:

;		min	max	mean
;	Timing:	44	188	172.77	clks

;       PM: 19               DM: 10

;----------------------------------------------------------------------------------------------

PROG	CODE

		EXTERN		FXD1608U

FXD3208U
		GLOBAL		FXD3208U

		MOVFP		AARGB0,WREG
		MOVWF		TEMPB0
		MOVFP		AARGB1,WREG
		MOVWF		TEMPB1
		MOVFP		AARGB2,WREG
		MOVWF		TEMPB2
		MOVFP		AARGB3,WREG
		MOVWF		TEMPB3

		CALL		FXD1608U

		MOVFP		AARGB0,WREG
		MOVWF		TEMPB0
		MOVFP		AARGB1,WREG
		MOVWF		TEMPB1

		MOVFP		TEMPB2,WREG
		MOVWF		AARGB1
		MOVFP		REMB0,WREG
		MOVWF		AARGB0

		CALL		FXD1608U

		MOVFP		AARGB1,WREG
		MOVWF		TEMPB2
		MOVFP		TEMPB3,WREG
		MOVWF		AARGB1
		MOVFP		REMB0,WREG
		MOVWF		AARGB0

		CALL		FXD1608U

		MOVFP		AARGB1,WREG
		MOVWF		AARGB3
		MOVFP		TEMPB0,WREG
		MOVWF		AARGB0
		MOVFP		TEMPB1,WREG
		MOVWF		AARGB1
		MOVFP		TEMPB2,WREG
		MOVWF		AARGB2

		RETLW       0x00

		END
